<?php


require '../system/core.php';

if(!$login) message('Введите пароль для доступа к данной функции!', '/admin/login.php');

if(!extension_loaded('curl'))
{
	message('На вашем сервере (хостинге) отсутствует необходимый модуль curl, для корректной работы импорта.', '/');
}

if(isset($_GET['parent_id']))
{
	$parent_id = num($_GET['parent_id']);
	
	$query = $db->query("SELECT * FROM `data` WHERE `id`='".$parent_id."' AND `type`='dir'");
	if($db->num($query) != 1)
	{
		message('Указанная родительская папка не найдена!', '/');
	}
	$result = $db->fetch($query);
	
	$parent_path = $result['path'];
}
else
{
	message('Не указана папка для загрузки файлов!', '/');
}

function get_url_mime_type($url)
{
	$ch = curl_init($url);
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
	//curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);
	curl_setopt($ch, CURLOPT_HEADER, 1);
	curl_setopt($ch, CURLOPT_NOBODY, 1);
	curl_exec($ch);
	return curl_getinfo($ch, CURLINFO_CONTENT_TYPE);
}


if(isset($_POST['name']) and isset($_POST['url']))
{
	$name = in($_POST['name']);
	$file = in($_POST['url']);
	
	
	if(empty($name))
	{
		message('Название видеофайла должно быть заполнено!');
	}
	if(empty($file))
	{
		message('Вы не указали URL удаленного файла!');
	}
	
	
	if(mb_strlen($name, 'utf-8') > 100)
	{
		message('Название файла не может быть больше 100 символов!');
	}
	
	
	$mime = get_url_mime_type($file);
	
	if($mime == 'image/png')
	{
		$extension = 'png';
	}
	elseif($mime == 'image/jpeg')
	{
		$extension = 'jpg';
	}
	elseif($mime == 'image/gif')
	{
		$extension = 'gif';
	}
	else
	{
		$extension = 'error';
	}
	
	
	$translit = translit($name);
	$path = $parent_path.'/'.$translit.'.'.$extension;
	$preview = $parent_path.'/preview_'.$translit.'.jpg';
	
	if(empty($translit))
	{
		message('Ошибка! Введите другое название!');
	}
	
	if($extension == 'error')
	{
		message('К загрузке допускаются только файлы формата: jpg, jpeg, gif, png!');
	}
	
	
	if(file_exists(ROOT.$path))
	{
		message('Файл с таким именем уже существует!');
	}
	
	
	/* Копируем файл */
	if(!copy($file, ROOT.$path))
	{
		message('Ошибка при копировании файла!');
	}	
	
	
	
	/* Размер файла в байтах */
	$size = filesize(ROOT.$path);
	
	
	/* Размеры */
	$imagesize = getimagesize(ROOT.$path);
	$width = $imagesize[0];
	$height = $imagesize[1];
	

	/* Создаем уменьшенную копию скриншота */
	imageresize(ROOT.$path, ROOT.$preview, 90, 90, 85);
	
	
	/* Записываем информацию о файле в БД */
	$db->query("INSERT INTO `data` SET `parent_id`='".$parent_id."', `type`='file', `name`='".$name."', `translit`='".$translit."', `parent_path`='".$parent_path."', `path`='".$path."', `size`='".$size."', `extension`='".$extension."', `width`='".$width."', `height`='".$height."', `preview`='".$preview."', `time`='".time()."'");

	update_count_files($db);
	message('Файл успешно загружен!', '/dir'.$parent_id);
}


$data['title'] = 'Импорт файла';
$data['parent_id'] = $parent_id;
$tpl->display('admin/import_file', $data);
?>