<?php


require '../system/core.php';

if(!$login) message('Введите пароль для доступа к данной функции!', '/admin/login.php');


if(isset($_GET['parent_id']))
{
	$parent_id = num($_GET['parent_id']);
	
	$query = $db->query("SELECT * FROM `data` WHERE `id`='".$parent_id."' AND `type`='dir'");
	if($db->num($query) != 1)
	{
		message('Указанная родительская папка не найдена!', '/');
	}
	$result = $db->fetch($query);
	
	$parent_path = $result['path'];
}
else
{
	message('Не указана папка для загрузки файлов!', '/');
}


if(isset($_POST['name']) and isset($_FILES['file']['name']))
{
	$name = in($_POST['name']);
	$file = in($_FILES['file']['name']);
	
	if(empty($name))
	{
		message('Название файла должно быть заполнено!');
	}
	if(empty($file))
	{
		message('Вы не выбрали файл!');
	}
	
	if($_FILES['file']['error'])
	{
		message('При загрузке файла произошла ошибка! Подробности: <b>'.$_FILES['file']['error'].'</b>.');
	}
	
	if(mb_strlen($name, 'utf-8') > 100)
	{
		message('Название файла не может быть больше 100 символов!');
	}
	
	
	$info = pathinfo($file);
	$extension = strtolower($info['extension']);
	$translit = translit($name);
	$path = $parent_path.'/'.$translit.'.'.$extension;
	$preview = $parent_path.'/preview_'.$translit.'.jpg';
	

	if($extension != 'jpg' and $extension != 'jpeg' and $extension != 'gif' and $extension != 'png')
	{
		message('К загрузке допускаются только файлы формата: jpg, jpeg, gif, png!');
	}
	

	if(file_exists(ROOT.$path))
	{
		message('Файл с таким именем уже существует!');
	}

	
	/* Копируем файл */
	if(!copy($_FILES['file']['tmp_name'], ROOT.$path))
	{
		message('Ошибка при копировании файла!');
	}	
	
	
	
	/* Размер файла в байтах */
	$size = $_FILES['file']['size'];
	
	
	/* Размеры */
	$imagesize = getimagesize(ROOT.$path);
	$width = $imagesize[0];
	$height = $imagesize[1];
	

	/* Создаем уменьшенную копию скриншота */
	imageresize(ROOT.$path, ROOT.$preview, 90, 90, 85);
	
	
	/* Записываем информацию о файле в БД */
	$db->query("INSERT INTO `data` SET `parent_id`='".$parent_id."', `type`='file', `name`='".$name."', `translit`='".$translit."', `parent_path`='".$parent_path."', `path`='".$path."', `size`='".$size."', `extension`='".$extension."', `width`='".$width."', `height`='".$height."', `preview`='".$preview."', `time`='".time()."'");

	update_count_files($db);
	message('Файл успешно загружен!', '/dir'.$parent_id);
}


$data['title'] = 'Загрузить файл';
$data['parent_id'] = $parent_id;
$tpl->display('admin/upload_file', $data);
?>